window.Gleam.initSearch([{"doc":"bungibindies","title":"bungibindies","content":"# bungibindies\n\nGleam bindings to the Bun runtime API&#39;s.\n\n[![Package Version](https://img.shields.io/hexpm/v/bungibindies)](https://hex.pm/packages/bungibindies)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/bungibindies/)\n\n&gt; WARNING - INCOMPLETE:\n&gt;\n&gt; Please note, not everything is implemented as of yet.\n&gt; See the [Development](#implementation) section for more information.\n\n```sh\ngleam add bungibindies@1\n```\n\n```gleam\nimport bungibindies/bun\nimport bungibindies/bun/serve\n\npub fn main() {\n  bun.serve(fn () {\n  serve.fetch(req: Request) {\n    Response(&quot;Success!&quot;)\n  },\n})\n}\n```\n\n(This is a rough sketch cuz I&#39;m just making code up rn)\n\nFurther documentation can be found at &lt;https://hexdocs.pm/bungibindies&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\n```\n\n### Dependencies\n\nI try to not use anything else than Bun itself,\nbut I do use `gleam/javascript` to use non-bun-specific JavaScript stuff.\n\n### Implementation\n\nBoxes are checked when the implementation is _usable_, if it&#39;s not\ncomplete but checked, should be in the `skipped` section along\nwith possibly the reason for skipping.\n\n- [ ] HTTP API&#39;s\n\n  - [ ] HTTP server\n    - [ ] `Bun.serve()`, `serve.fetch()` and alike\n    - [ ] WebSocket server\n  - [ ] HTTP client\n    - [ ] `Bun.fetch()\n\n- [ ] Bundler\n\n  - [ ] `Bun.bundle()`\n\n- Workers\n\n- [ ] Binary data\n\n  - [ ] Types\n\n- [ ] Streams\n\n  - [ ] Stream types\n  - [ ] Stream API&#39;s\n\n- [ ] File I/O\n\n  - [x] `Bunfile` type\n  - [ ] Reading (`Bun.file()` ...)\n    - [x] `Bun.file()`, `Bun.text()`, `Bun.json()` ...\n    - [ ] `Bun.stdin`\n    - [ ] `Bun.stdout`\n    - [ ] `Bun.stderr`\n  - [x] Writing (`Bun.write()`)\n\n- import.meta\n\n- [ ] SQLite\n\n  - [ ] `New` returning a `Bun.Database` in the\n        form of a set of functions and interfaces.\n\n- Globals\n\n- [ ] $ Shell -- if possible to implement\n\n- [ ] Child processes\n\n  - [ ] `Bun.spawn()`\n  - [ ] `Bun.exec()`\n  - [ ] `Bun.execSync()`\n  - [ ] `Bun.spawnSync()`\n\n- [ ] TCP\n\n  - [ ] `Bun.listen()`\n  - [ ] `Bun.connect()`\n\n- [ ] Transpiler\n\n  - [ ] `New` returning a `Bun.Transpiler` in the form of\n        a set of functions and interfaces.\n\n- [ ] Hashing\n\n  - [ ] `Bun.password_hash()` and `Bun.password_verify()`\n  - [ ] `Bun.hash()`\n\n- Console\n\n- [ ] FFI\n- [ ] HTMLRewriter\n- [ ] Testing\n- [x] Utilities\n\n  - [x] `Bun.version`\n  - [x] `Bun.revision`\n  - [x] `Bun.env`\n  - [x] `Bun.main`\n  - [x] `Bun.sleep()`\n  - [x] `Bun.sleepSync()`\n  - [x] `Bun.which()`\n  - [x] `Bun.randomUUIDv7()`\n  - [x] `Bun.peek()`\n  - [x] `Bun.openInEditor()`\n  - [x] `Bun.deepEquals()`\n  - [x] `Bun.escapeHTML()`\n  - [x] `Bun.stringWidth()`\n  - [x] `Bun.fileURLToPath()`\n  - [x] `Bun.pathToFileURL()`\n  - `Bun.gzipSync`\n  - `Bun.gunzipSync`\n  - `Bun.deflateSync`\n  - `Bun.inflateSync`\n  - [x] `Bun.inspect()`\n  - [x] `Bun.nanoseconds()`\n  - `Bun.readableStreamTo*()`\n  - [x] `Bun.resolveSync()`\n  - `serialize` &amp; `deserialize` in `bun:jsc`\n\n- DNS\n\n#### Skipped\n\nSome implementations were skipped for now. Here is a little list of what I skipped.\nIf you want to help, feel free to implement them and make a PR,\nor wait until I get to them :)\n\n- Utilities -&gt; `Bun.gzipSync`: Not sure how to implement this yet.\n- Utilities -&gt; `Bun.gunzipSync`: Not sure how to implement this yet.\n- Utilities -&gt; `Bun.deflateSync`: Not sure how to implement this yet.\n- Utilities -&gt; `Bun.inflateSync`: Not sure how to implement this yet.\n- Utilities -&gt; `Bun.readableStreamTo*()`: Not sure how to implement this.\n- Utilities -&gt; `serialize` &amp; `deserialize` in `bun:jsc`:\n  Not sure how to implement this.\n- Console: Not sure how to implement this yet.\n- DNS: Not stable enough yet.\n- `import.meta`: Gleam modules are not accessible from Bun\n  API&#39;s, maybe through source maps in the future.\n- Workers: Not stable enough yet.\n- Globals: Not relevant to the scope of this library. (Mostly contains\n  browser-related globals. Some Bun ones, but those ought to be\n  implemented elsewhere.)\n\n#### Workarounds\n","url":"index.html"},{"doc":"bungibindies","title":"main","content":"pub fn main() -&gt; Nil\n\nSynonyms:\nbungibindies.main\nbungibindies main","url":"bungibindies.html#main"},{"doc":"bungibindies","title":"bungibindies","content":" Please see bungibindies/bun for usefull stuff.","url":"bungibindies.html"},{"doc":"bungibindies/bun/bunfile","title":"BunFile","content":"pub type BunFile\n A `BunFile` represents a lazily-loaded file; initializing it does not actually read the file from disk.\n\nSynonyms:\nbungibindies/bun/bunfile.BunFile\nbungibindies/bun/bunfile BunFile","url":"bungibindies/bun/bunfile.html#BunFile"},{"doc":"bungibindies/bun/bunfile","title":"json","content":"pub fn json(file: BunFile) -&gt; Promise(Dynamic)\n [`Bunfile.json()`](https://bun.sh/docs/api/file-io#reading-files-bun-file)\n - File I/O\n\n Read the contents of a file as a JSON object.\nSynonyms:\nbungibindies/bun/bunfile.json\nbungibindies/bun/bunfile json","url":"bungibindies/bun/bunfile.html#json"},{"doc":"bungibindies/bun/bunfile","title":"stderr","content":"pub fn stderr() -&gt; BunFile\n [`Bun.stderr`](https://bun.sh/docs/api/file-io#writing-files-bun-write)\n\n Write to stderr\nSynonyms:\nbungibindies/bun/bunfile.stderr\nbungibindies/bun/bunfile stderr","url":"bungibindies/bun/bunfile.html#stderr"},{"doc":"bungibindies/bun/bunfile","title":"stdin","content":"pub fn stdin() -&gt; BunFile\n [`Bun.stdin`](https://bun.sh/docs/api/file-io#reading-files-bun-file)\n Read from stdin\n \nThis is read-only\nSynonyms:\nbungibindies/bun/bunfile.stdin\nbungibindies/bun/bunfile stdin","url":"bungibindies/bun/bunfile.html#stdin"},{"doc":"bungibindies/bun/bunfile","title":"stdout","content":"pub fn stdout() -&gt; BunFile\n [`Bun.stdout`](https://bun.sh/docs/api/file-io#writing-files-bun-write)\n \n Write to stdout\nSynonyms:\nbungibindies/bun/bunfile.stdout\nbungibindies/bun/bunfile stdout","url":"bungibindies/bun/bunfile.html#stdout"},{"doc":"bungibindies/bun/bunfile","title":"text","content":"pub fn text(file: BunFile) -&gt; Promise(String)\n [`Bunfile.text()`](https://bun.sh/docs/api/file-io#reading-files-bun-file)\n - File I/O\n\n Read the contents of a file as a string.\nSynonyms:\nbungibindies/bun/bunfile.text\nbungibindies/bun/bunfile text","url":"bungibindies/bun/bunfile.html#text"},{"doc":"bungibindies/bun/bunfile","title":"bungibindies/bun/bunfile","content":" A `BunFile` represents a lazily-loaded file; initializing it does not actually read the file from disk.\n \n &gt; **Note** — The `Bun.file` and `Bun.write` APIs documented on this page are heavily optimized and represent the recommended way to perform file-system tasks using Bun. For operations that are not yet available with `Bun.file`, such as `mkdir` or `readdir`, you can use Bun&#39;s [nearly complete](https://bun.sh/docs/runtime/nodejs-apis#node-fs) implementation of the [`node:fs`](https://nodejs.org/api/fs.html) module.","url":"bungibindies/bun/bunfile.html"},{"doc":"bungibindies/bun","title":"deep_equals","content":"pub fn deep_equals(a: a, b: a) -&gt; Bool\n [`Bun.deepEquals()`](https://bun.sh/docs/api/utils#bun-deepequals)\n - Utilities\n\n &gt; Recursively checks if two objects are equivalent. This is used internally by `expect().toEqual()` in `bun/test`.\nSynonyms:\nbungibindies/bun.deep_equals\nbungibindies/bun deep_equals","url":"bungibindies/bun.html#deep_equals"},{"doc":"bungibindies/bun","title":"deep_equals_strict","content":"pub fn deep_equals_strict(a: a, b: a) -&gt; Bool\n [`Bun.deepEquals()`](https://bun.sh/docs/api/utils#bun-deepequals)\n - Utilities\n\n &gt; Recursively checks if two objects are equivalent. This is used internally by `expect().toEqual()` in `bun/test`.\nSynonyms:\nbungibindies/bun.deep_equals_strict\nbungibindies/bun deep_equals_strict","url":"bungibindies/bun.html#deep_equals_strict"},{"doc":"bungibindies/bun","title":"env","content":"pub fn env(key: String) -&gt; Result(String, Nil)\n [`Bun.env`](https://bun.sh/docs/api/utils#bun-env)\n - Utilities\n\n &gt; Fetches the value of an environment variable.\nSynonyms:\nbungibindies/bun.env\nbungibindies/bun env","url":"bungibindies/bun.html#env"},{"doc":"bungibindies/bun","title":"escape_html","content":"pub fn escape_html(value: a) -&gt; String\n [`Bun.escapeHTML()`](https://bun.sh/docs/api/utils#bun-escapehtml)\n - Utilities\n\n &gt; `Bun.escapeHTML(value: string | object | number | boolean): string`\n Escapes the following characters from an input string:\n\n &gt; - `&quot;` becomes `&amp;quot;`\n - `&amp;` becomes `&amp;amp;`\n - `&#39;` becomes `&amp;#x27;`\n - `&lt;` becomes `&amp;lt;`\n - `&gt;` becomes `&amp;gt;`\n\n &gt; This function is optimized for large input. On an M1X, it processes 480 MB/s -\n 20 GB/s, depending on how much data is being escaped and whether there is non-ascii\n text. Non-string types will be converted to a string before escaping.\nSynonyms:\nbungibindies/bun.escape_html\nbungibindies/bun escape_html","url":"bungibindies/bun.html#escape_html"},{"doc":"bungibindies/bun","title":"file","content":"pub fn file(path: String) -&gt; BunFile\n [`Bun.file()`](https://bun.sh/docs/api/fs#bun-file)\n - File I/O\n\n Create a BunFile instance with the `Bun.file(path)` function.\nSynonyms:\nbungibindies/bun.file\nbungibindies/bun file","url":"bungibindies/bun.html#file"},{"doc":"bungibindies/bun","title":"file_url_to_path","content":"pub fn file_url_to_path(url: String) -&gt; String\n [`Bun.fileURLToPath()`](https://bun.sh/docs/api/utils#bun-fileurltopath)\n - Utilities\n\n &gt; Converts a file URL to a file path.\nSynonyms:\nbungibindies/bun.file_url_to_path\nbungibindies/bun file_url_to_path","url":"bungibindies/bun.html#file_url_to_path"},{"doc":"bungibindies/bun","title":"inspect","content":"pub fn inspect(value: a) -&gt; String\n [`Bun.inspect()`](https://bun.sh/docs/api/utils#bun-inspect)\n - Utilities\n\n &gt; Returns a string representation of an object.\nSynonyms:\nbungibindies/bun.inspect\nbungibindies/bun inspect","url":"bungibindies/bun.html#inspect"},{"doc":"bungibindies/bun","title":"main_","content":"pub fn main_() -&gt; String\n [`Bun.main`](https://bun.sh/docs/api/utils#bun-main)\n - Utilities\n\n &gt; An absolute path to the entrypoint javascript module of the current program (the file that was executed with bun run).\nSynonyms:\nbungibindies/bun.main_\nbungibindies/bun main_","url":"bungibindies/bun.html#main_"},{"doc":"bungibindies/bun","title":"nanoseconds","content":"pub fn nanoseconds() -&gt; Float\n [`Bun.nanoseconds()`](https://bun.sh/docs/api/utils#bun-nanoseconds)\n - Utilities\n\n &gt; Returns the number of nanoseconds since the current `bun` process started, as a `number`. Useful for high-precision timing and benchmarking.\nSynonyms:\nbungibindies/bun.nanoseconds\nbungibindies/bun nanoseconds","url":"bungibindies/bun.html#nanoseconds"},{"doc":"bungibindies/bun","title":"open_in_editor","content":"pub fn open_in_editor(path: String) -&gt; Nil\n [`Bun.openInEditor()`](https://bun.sh/docs/api/utils#bun-openineditor)\n - Utilities\n\n &gt; Opens a file in the user&#39;s editor.\nSynonyms:\nbungibindies/bun.open_in_editor\nbungibindies/bun open_in_editor","url":"bungibindies/bun.html#open_in_editor"},{"doc":"bungibindies/bun","title":"open_in_editor_with_options","content":"pub fn open_in_editor_with_options(\n  path: String,\n  options: Map(String, String),\n) -&gt; Nil\n [`Bun.openInEditor()`](https://bun.sh/docs/api/utils#bun-openineditor)\n - Utilities\n\n &gt; Opens a file in the user&#39;s editor.\nSynonyms:\nbungibindies/bun.open_in_editor_with_options\nbungibindies/bun open_in_editor_with_options","url":"bungibindies/bun.html#open_in_editor_with_options"},{"doc":"bungibindies/bun","title":"path_to_file_url","content":"pub fn path_to_file_url(path: String) -&gt; String\n [`Bun.pathToFileURL()`](https://bun.sh/docs/api/utils#bun-pathtofileurl)\n - Utilities\n\n &gt; Converts a file path to a file URL.\nSynonyms:\nbungibindies/bun.path_to_file_url\nbungibindies/bun path_to_file_url","url":"bungibindies/bun.html#path_to_file_url"},{"doc":"bungibindies/bun","title":"peek","content":"pub fn peek(promise: Promise(a)) -&gt; Result(a, Nil)\n [`Bun.peek()`](https://bun.sh/docs/api/utils#bun-peek)\n - Utilities\n\n &gt; Reads a promise&#39;s result without await or .then, but only if the promise has already fulfilled or rejected.\nSynonyms:\nbungibindies/bun.peek\nbungibindies/bun peek","url":"bungibindies/bun.html#peek"},{"doc":"bungibindies/bun","title":"random_uuid_v7","content":"pub fn random_uuid_v7() -&gt; String\n [`Bun.randomUUIDv7()](https://bun.sh/docs/api/utils#bun-randomuuidv7)\n - Utilities\n\n &gt; Returns a UUID v7, which is monotonic and suitable for sorting and databases.\nSynonyms:\nbungibindies/bun.random_uuid_v7\nbungibindies/bun random_uuid_v7","url":"bungibindies/bun.html#random_uuid_v7"},{"doc":"bungibindies/bun","title":"random_uuid_v7_buffer","content":"pub fn random_uuid_v7_buffer() -&gt; Array(Int)\n [`Bun.randomUUIDv7()`](https://bun.sh/docs/api/utils#bun-randomuuidv7)\n - Utilities\n\n &gt; Returns a UUID v7, which is monotonic and suitable for sorting and databases as a buffer.\nSynonyms:\nbungibindies/bun.random_uuid_v7_buffer\nbungibindies/bun random_uuid_v7_buffer","url":"bungibindies/bun.html#random_uuid_v7_buffer"},{"doc":"bungibindies/bun","title":"resolve_sync","content":"pub fn resolve_sync(module: String, parent: String) -&gt; String\n [`Bun.resolveSync()`](https://bun.sh/docs/api/utils#bun-resolvesync)\n - Utilities\n\n &gt; Resolves a file path or module specifier using Bun&#39;s internal module resolution algorithm. The first argument is the path to resolve, and the second argument is the &quot;root&quot;. If no match is found, an `Error` is thrown.\nSynonyms:\nbungibindies/bun.resolve_sync\nbungibindies/bun resolve_sync","url":"bungibindies/bun.html#resolve_sync"},{"doc":"bungibindies/bun","title":"revision","content":"pub fn revision() -&gt; String\n [`Bun.revision`](https://bun.sh/docs/api/utils#bun-revision)\n - Utilities\n\n &gt; A string containing the git revision of the bun CLI that is currently running.\nSynonyms:\nbungibindies/bun.revision\nbungibindies/bun revision","url":"bungibindies/bun.html#revision"},{"doc":"bungibindies/bun","title":"sleep","content":"pub fn sleep(ms: Float) -&gt; Nil\n [`Bun.sleep()`](https://bun.sh/docs/api/utils#bun-sleep)\n - Utilities\n\n &gt; Sleeps for the given number of milliseconds.\nSynonyms:\nbungibindies/bun.sleep\nbungibindies/bun sleep","url":"bungibindies/bun.html#sleep"},{"doc":"bungibindies/bun","title":"sleep_sync","content":"pub fn sleep_sync(ms: Float) -&gt; Nil\n [`Bun.sleepSync()`](https://bun.sh/docs/api/utils#bun-sleepsync)\n - Utilities\n\n &gt; Sleeps for the given number of milliseconds synchronously.\nSynonyms:\nbungibindies/bun.sleep_sync\nbungibindies/bun sleep_sync","url":"bungibindies/bun.html#sleep_sync"},{"doc":"bungibindies/bun","title":"string_width","content":"pub fn string_width(\n  value: String,\n  count_ansi_escape_codes: Bool,\n  ambiguous_is_narrow: Bool,\n) -&gt; Int\n [`Bun.stringWidth()`](https://bun.sh/docs/api/utils#bun-stringwidth)\n - Utilities\n\n &gt; Get the column count of a string as it would be displayed in a terminal.\n Supports ANSI escape codes, emoji, and wide characters.\nSynonyms:\nbungibindies/bun.string_width\nbungibindies/bun string_width","url":"bungibindies/bun.html#string_width"},{"doc":"bungibindies/bun","title":"version","content":"pub fn version() -&gt; String\n [`Bun.version`](https://bun.sh/docs/api/utils#bun-version)\n - Utilities\n\n &gt; A string containing the version of the bun CLI that is currently running.\nSynonyms:\nbungibindies/bun.version\nbungibindies/bun version","url":"bungibindies/bun.html#version"},{"doc":"bungibindies/bun","title":"which","content":"pub fn which(executable: String) -&gt; Result(String, Nil)\n [`Bun.which()`](https://bun.sh/docs/api/utils#bun-which)\n - Utilities\n\n &gt; Returns the path to the given executable if it is in the PATH.\nSynonyms:\nbungibindies/bun.which\nbungibindies/bun which","url":"bungibindies/bun.html#which"},{"doc":"bungibindies/bun","title":"which_with_options","content":"pub fn which_with_options(\n  executable: String,\n  options: Map(String, String),\n) -&gt; Result(String, Nil)\n [`Bun.which()`](https://bun.sh/docs/api/utils#bun-which)\n - Utilities\n\n &gt; Returns the path to the given executable if it is in the PATH\nSynonyms:\nbungibindies/bun.which_with_options\nbungibindies/bun which_with_options","url":"bungibindies/bun.html#which_with_options"},{"doc":"bungibindies/bun","title":"write","content":"pub fn write(destination: BunFile, data: a) -&gt; Promise(Int)\n [`Bun.write()`](https://bun.sh/docs/api/fs#bun-write)\n - File I/O\n\n The `Bun.write` function is a multi-tool for writing payloads of all kinds to disk.\n\n @param destination — The file to write to\n @param data — The data to copy into destination.\n @returns — A promise that resolves with the number of bytes written.\nSynonyms:\nbungibindies/bun.write\nbungibindies/bun write","url":"bungibindies/bun.html#write"},{"doc":"bungibindies/bun","title":"bungibindies/bun","content":" Gleam bindings to the Bun runtime API&#39;s.","url":"bungibindies/bun.html"},{"doc":"bungibindies/bun/ffi","title":"bungibindies/bun/ffi","content":" # `Bun:ffi` module","url":"bungibindies/bun/ffi.html"},{"doc":"bungibindies/bun/sqlite","title":"bungibindies/bun/sqlite","content":" # `Bun:sqlite` module","url":"bungibindies/bun/sqlite.html"},{"doc":"bungibindies/bun/t_st","title":"bungibindies/bun/t_st","content":" # `Bun:test` module","url":"bungibindies/bun/t_st.html"}]);